#!/usr/bin/php
<?php

set_include_path(get_include_path() . PATH_SEPARATOR . "/usr/local/mgr5/include/php");
define('__MODULE__', "pmbrainy");

require_once 'bill_util.php';

/**
 * [$longopts description]
 * @var array
 */
$longopts  = array
(
    "command:",
    "subcommand:",
    "id:",
    "item:",
    "lang:",
    "module:",
    "itemtype:",
    "intname:",
    "param:",
    "value:",
    "runningoperation:",
    "level:",
    "addon:",
// brainy specific
    "tld:",
    "searchstring:",
);

$options = getopt("", $longopts);

function GetConnection() {
	$param = LocalQuery("paramlist", array());
	$result = $param->xpath('//elem/*');

	$param_map = array();
	$param_map["DBHost"] = "localhost";
	$param_map["DBUser"] = "root";
	$param_map["DBPassword"] = "";
	$param_map["DBName"] = "billmgr";

	while(list( , $node) = each($result)) {
	    $param_map[$node->getName()] = $node;
	}

	return new DB($param_map["DBHost"], $param_map["DBUser"], $param_map["DBPassword"], $param_map["DBName"]);
}

function ItemParam($db, $iid) {
	$res = $db->query("SELECT i.id AS item_id, i.processingmodule AS item_module, i.period AS item_period, i.status AS item_status, i.expiredate, 
							  tld.name AS tld_name 
					   FROM item i 
					   JOIN pricelist p ON p.id = i.pricelist 
					   JOIN tld ON tld.id = p.intname 
					   WHERE i.id=" . $iid);

	if ($res == FALSE)
		throw new Error("query", $db->error);

    $param = $res->fetch_assoc();

    $param_res = $db->query("SELECT intname, value FROM itemparam WHERE item = ".$iid);
    while ($row = $param_res->fetch_assoc()) {
    	$param[$row["intname"]] = $row["value"];
    }

    return $param;
}

function ItemProfiles($db, $iid, $module) {
	$param = array();
	$res = $db->query("SELECT sp2i.service_profile AS service_profile, sp2i.type AS type, sp2p.externalid AS externalid, sp2p.externalpassword AS externalpassword 
					   FROM item i 
					   JOIN service_profile2item sp2i ON sp2i.item = i.id 
					   LEFT JOIN service_profile2processingmodule sp2p ON sp2p.service_profile = sp2i.service_profile AND sp2i.type = sp2p.type 
					   WHERE i.id=" . $iid);
	Debug("ItemProfiles START:\r\n");
	while ($row = $res->fetch_assoc()) {
		Debug("ROW:\r\n");
		DebugArray($row);
	}
	return;

	while ($row = $res->fetch_assoc()) {
    	$param[$row["type"]] = array();
    	$param[$row["type"]]["externalid"] = $row["externalid"];
    	$param[$row["type"]]["externalpassword"] = $row["externalpassword"];
    	$param[$row["type"]]["service_profile"] = $row["service_profile"];

    	$profile_res = $db->query("SELECT intname, value 
					   FROM service_profileparam 
					   WHERE service_profile=" . $row["service_profile"]);

    	while ($profile_row = $profile_res->fetch_assoc()) {
    		$param[$row["type"]][$profile_row["intname"]] = $profile_row["value"];
    	}
    }

    return $param;
}

function getModuleParams($sid) {
	if ($sid != "") {
		$param = LocalQuery("processing.edit", array("elid" => $sid));
		$out = array();
		foreach ($param as $key => $val) {
			if (mb_strlen(trim($key))) {
				$out[$key] = $val;
			}
		}
		return $out;
	}
}

function getItemInfo($db, $iid) {
	$res = $db->query("SELECT *
					   FROM item i 
					   WHERE i.id=" . $iid);
	$row = $res->fetch_assoc();

	$res = $db->query("SELECT * FROM itemparam WHERE item=".$iid);
	while ($param = $res->fetch_assoc()) {
		$row["params"][] = $param;
	}

	return $row;
}

function getPricelistInfo($db, $iid, $pricelist) {
	$res = $db->query("SELECT *
					   FROM pricelist p 
					   WHERE p.parent=" . $pricelist);
	$row = $res->fetch_assoc();
}

function getProtectedFieldName($db) {
	$q = "SELECT *
		   FROM itemtype t 
		   WHERE t.intname = 'privacy'";

	$res = $db->query($q);
	$row = $res->fetch_assoc();

	$field_name = $row["name"];

	return $field_name;
}

function checkItemDataProtection($service_details, $field_name) {
	$protected = false;

	foreach ($service_details->elem as $elem) {
		$elem_name = (string) $elem->name;

		if ($elem_name == $field_name) {
			$elem_val = (string) $elem->value;
			if ($elem_val == "On") {
				$protected = true;
				break;
			}
		}
	}

	return $protected;
}

function getClientInfo($uid) {
	$param = LocalQuery("account.edit", array("elid" => $uid));
	$out = array();
	foreach ($param as $key => $val) {
		if (mb_strlen(trim($key))) {
			$out[$key] = $val;
		}
	}
	return $out;
}

function getVHostParams($id) {
	$param = LocalQuery("vhost.edit", array("elid" => $id));
	$out = array();
	foreach ($param as $key => $val) {
		$out[$key] = $val;
	}
	return $out;
}


try {
	$command = $options['command'];
	$runningoperation = array_key_exists("runningoperation", $options) ? (int)$options['runningoperation'] : 0;
	$item = array_key_exists("item", $options) ? (int)$options['item'] : 0;

	$opts = ""; foreach ($options as $k=>$v) {$opts .= "$k = $v \r\n";}
	Debug("command ". $options['command'] . ", item: " . $item . ", operation: " . $runningoperation." . OPTIONS PARAMS:\r\n".$opts);

	if ($command == "features") {

		$config_xml = simplexml_load_string($default_xml_string);

		$itemtypes_node = $config_xml->addChild("itemtypes");
		$itemtypes_node->addChild("itemtype")->addAttribute("name", "vhost");

		
		$params_node = $config_xml->addChild("params");
		$params_node->addChild("param")->addAttribute("name", "brainy_login");
		$params_node->addChild("param")->addAttribute("name", "brainy_password");
		$params_node->addChild("param")->addAttribute("name", "brainy_url");
		$params_node->addChild("param")->addAttribute("name", "brainy_group");
		$params_node->addChild("param")->addAttribute("name", "brainy_ip");

		$params_node->addChild("param")->addAttribute("name", "username");
		$password = $params_node->addChild("param");
		$password->addAttribute("name", "password");
		$password->addAttribute("crypted", "yes");
		$params_node->addChild("param")->addAttribute("name", "dbname");
		$params_node->addChild("param")->addAttribute("name", "dbhost");

		$features_node = $config_xml->addChild("features");
		$features_node->addChild("feature")->addAttribute("name", "datacenter");
		$features_node->addChild("feature")->addAttribute("name", "open");
		$features_node->addChild("feature")->addAttribute("name", "close");
		$features_node->addChild("feature")->addAttribute("name", "suspend");
		$features_node->addChild("feature")->addAttribute("name", "resume");
		$features_node->addChild("feature")->addAttribute("name", "setparam");
		

		echo $config_xml->asXML();

	} elseif ($command == "open") {

		$db = GetConnection();

		$iid = $options['item'];

		$item_all_info = getItemInfo($db, $iid);
		//Debug("ITEM ALL INFO:\r\n");
		//DebugArray($item_all_info);

		$module_params = getModuleParams($item_all_info["processingmodule"]);
		//Debug("module_params:\r\n");
		//DebugArray($module_params);

		$client_info = getClientInfo($item_all_info["account"]);
		//Debug("client_info:\r\n");
		//DebugArray($client_info);
		$tmpName = explode(" ", $client_info["name"]);
		$client_firstname = trim($tmpName[0]);
		$client_lasttname = trim($tmpName[1]);
		$tmpName = explode(" (", $client_info["name"]);
		$client_email = str_replace(")", "", $tmpName[1]);


		$brainy_url = $module_params["brainy_url"];
		$api_login = $module_params["brainy_login"];
		$api_pswd = $module_params["brainy_password"];
		$brainy_group = $module_params["brainy_group"];
		$brainy_ip = $module_params["brainy_ip"];
		$brainy_user_login = "bm".$item_all_info["id"];
		$brainy_user_password = mb_substr(md5(time()), 0, 8);
		$tmpPlanName = explode(" #".$item_all_info["id"], $item_all_info["name"]);
		$brainy_tarif = trim($tmpPlanName[0]);

		$user_domain = "";
		foreach ($item_all_info["params"] as $param_arr) {
			if ($param_arr["intname"] == "domain") {
				$user_domain = $param_arr["value"];
			}
		}
		
		$url = $brainy_url;
		$params = array(
			"module" => "hostacc",
			"subdo" => "adduseracc",
			"login" => $api_login,//хост аккаунт от которого добавляется
			"pass" => $api_pswd,
			"group" => $brainy_group,//группа тоже
			"ip" => $brainy_ip,
			"lg" => $brainy_user_login,//логин нового пользователя
			"ps" => $brainy_user_password,//пароль нового пользователя
			"plan" => $brainy_tarif,//тарифный план должен присутствовать
		);
		foreach ($params as $key => $val) {
			$url .= $key."=".urlencode($val)."&";
		}

		Debug("Brainy URL: ".$url."; Brainy params:\r\n");
		DebugArray($params);

		$response = file_get_contents($url);
		Debug("Brainy response: ".$response);

		if ($response) {
			$response = json_decode($response, true);
			if ($response["err"] == 1) {
				throw new Error("Brainy error: ".$response["mess"]);
			} else {
				$edit_params = array(
					"elid" => $item_all_info["id"], 
					"ip" => $brainy_ip,
					"domain" => $user_domain,
					"username" => $brainy_user_login,
					"password" => $brainy_user_password,
					"sok" => "ok"
				);
				DebugArray($edit_params);
				$bm_rez = LocalQuery("vhost.open", $edit_params);
				Debug("BM vhost.open response: ");
				DebugArray($bm_rez);				
			}
		} else {
			throw new Error("Brainy no connection");
		}
		//Array ( [err] => 0 [mess] => Хост аккаунт успешно добавлен ) 
		//Array ( [err] => 1 [mess] => Пользователь с таким именем уже существует )


	} elseif ($command == "suspend") {
		$db = GetConnection();

		$iid = $options['item'];

		$item_all_info = getItemInfo($db, $iid);
		$module_params = getModuleParams($item_all_info["processingmodule"]);
		
		$brainy_url = $module_params["brainy_url"];
		$api_login = $module_params["brainy_login"];
		$api_pswd = $module_params["brainy_password"];
		$brainy_user_login = "bm".$item_all_info["id"];
		
		$url = $brainy_url;
		$params = array(
			"module" => "hostacc",
			"subdo" => "suspendacc",
			"action" => "suspend_full",
			"login" => $api_login,
			"pass" => $api_pswd,
			"panel_user" => $brainy_user_login,
		);
		foreach ($params as $key => $val) {
			$url .= $key."=".urlencode($val)."&";
		}

		Debug("Brainy URL: ".$url."; Brainy params:\r\n");
		DebugArray($params);

		$response = file_get_contents($url);
		Debug("Brainy response: ".$response);

		LocalQuery("service.postsuspend", array("elid" => $item_all_info["id"], "sok" => "ok"));


	} elseif ($command == "resume") {
		$db = GetConnection();

		$iid = $options['item'];

		$item_all_info = getItemInfo($db, $iid);
		$module_params = getModuleParams($item_all_info["processingmodule"]);
		
		$brainy_url = $module_params["brainy_url"];
		$api_login = $module_params["brainy_login"];
		$api_pswd = $module_params["brainy_password"];
		$brainy_user_login = "bm".$item_all_info["id"];
		
		$url = $brainy_url;
		$params = array(
			"module" => "hostacc",
			"subdo" => "unsuspendacc",
			"action" => "unsuspend_full",
			"login" => $api_login,
			"pass" => $api_pswd,
			"panel_user" => $brainy_user_login,
		);
		foreach ($params as $key => $val) {
			$url .= $key."=".urlencode($val)."&";
		}

		Debug("Brainy URL: ".$url."; Brainy params:\r\n");
		DebugArray($params);

		$response = file_get_contents($url);
		Debug("Brainy response: ".$response);

		LocalQuery("service.postresume", array("elid" => $item_all_info["id"], "sok" => "ok"));


	} elseif ($command == "close") {
		$db = GetConnection();

		$iid = $options['item'];

		$item_all_info = getItemInfo($db, $iid);
		$module_params = getModuleParams($item_all_info["processingmodule"]);
		
		$brainy_url = $module_params["brainy_url"];
		$api_login = $module_params["brainy_login"];
		$api_pswd = $module_params["brainy_password"];
		$brainy_user_login = "bm".$item_all_info["id"];
		
		$url = $brainy_url;
		$params = array(
			"module" => "hostacc",
			"subdo" => "deluseracc",
			"login" => $api_login,
			"pass" => $api_pswd,
			"panel_user" => $brainy_user_login,
		);
		foreach ($params as $key => $val) {
			$url .= $key."=".urlencode($val)."&";
		}

		Debug("Brainy URL: ".$url."; Brainy params:\r\n");
		DebugArray($params);

		$response = file_get_contents($url);
		Debug("Brainy response: ".$response);

		LocalQuery("service.postclose", array("elid" => $item_all_info["id"], "sok" => "ok"));


	} elseif ($command == "setparam") {
		Debug("SETPARAM!\r\n");

		$db = GetConnection();

		$iid = $options['item'];

		$item_all_info = getItemInfo($db, $iid);
		$module_params = getModuleParams($item_all_info["processingmodule"]);		
		$edit_params = array(
			"elid" => $item_all_info["id"], 
			"sok" => "ok"
		);
		$vhost_params = getVHostParams($iid);

		$brainy_url = $module_params["brainy_url"];
		$api_login = $module_params["brainy_login"];
		$api_pswd = $module_params["brainy_password"];
		$brainy_user_login = "bm".$item_all_info["id"];
		$brainy_pswd = $vhost_params['password'];
		$tmpPlanName = explode(" #".$item_all_info["id"], $item_all_info["name"]);
		$brainy_tarif = trim($tmpPlanName[0]);

		$user_domain = "";
		foreach ($item_all_info["params"] as $param_arr) {
			if ($param_arr["intname"] == "domain") {
				$user_domain = $param_arr["value"];
			}
		}
		
		$url = $brainy_url;
		$params = array(
			"module" => "hostacc",
			"subdo" => "edituseracc",
			"login" => $api_login,
			"pass" => $api_pswd,
			"plan_acc" => 1,
			"plan" => $brainy_tarif,
			"panel_user" => $brainy_user_login,
		);

		foreach ($params as $key => $val) {
			$url .= $key."=".urlencode($val)."&";
		}

		Debug("Brainy URL: ".$url."; Brainy params:\r\n");
		DebugArray($params);

		$response = file_get_contents($url);
		Debug("Brainy response: ".$response);

		if ($response) {
			$response = json_decode($response, true);
			if ($response["err"] == 1) {
				Debug("Тарифный план изменить не удалось из-за ошибки в Brainy. Откатываемся назад для пользователя ".$brainy_user_login);
				$edit_params = array(
					"elid" => $item_all_info["id"], 
					"userid" => $item_all_info["account"],
					"sok" => "ok"
				);
				DebugArray($edit_params);
				$bm_rez = LocalQuery("service.changepricelist.rollback", $edit_params);
				Debug("BM service.changepricelist.rollback response: ");
				DebugArray($bm_rez);

				throw new Error("Brainy error: ".$response["mess"]);
			} else {
				Debug("Тарифный план успешно изменен для пользователя: ".$brainy_user_login);
				$edit_params = array(
					"elid" => $item_all_info["id"], 
					"sok" => "ok"
				);
				DebugArray($edit_params);
				$bm_rez = LocalQuery("service.postsetparam", $edit_params);
				Debug("BM service.postsetparam response: ");
				DebugArray($bm_rez);
			}
		} else {
			throw new Error("Brainy no connection");
		}

	} elseif ($command == "datacenter") {
		//
	}
} catch (Exception $e) {
	if ($runningoperation > 0) {
		// save error message for operation in BILLmanager
		LocalQuery("runningoperation.edit", array("sok" => "ok", "elid" => $runningoperation, "errorxml" => $e,));

		if ($item > 0) {
			// set manual rerung
			LocalQuery("runningoperation.setmanual", array("elid" => $runningoperation,));

			// create task
			$task_type = LocalQuery("task.gettype", array("operation" => $command,))->task_type;
			if ($task_type != "") {
				LocalQuery("task.edit", array("sok" => "ok", "item" => $item, "runningoperation" => $runningoperation, "type" => $task_type, ));
			}
		}
	}

	echo $e;
}
